/*
 * Copyright [2022] [https://www.xiaonuo.vip]
 *
 * Snowy采用APACHE LICENSE 2.0开源协议，您在使用过程中，需要注意以下几点：
 *
 * 1.请不要删除和修改根目录下的LICENSE文件。
 * 2.请不要删除和修改Snowy源码头部的版权声明。
 * 3.本项目代码可免费商业使用，商业使用请保留源码和相关描述文件的项目出处，作者声明等。
 * 4.分发源码时候，请注明软件出处 https://www.xiaonuo.vip
 * 5.不可二次分发开源参与同类竞品，如有想法可联系团队xiaonuobase@qq.com商议合作。
 * 6.若您的项目无法满足以上几点，需要更多功能代码，获取Snowy商业授权许可，请在官网购买授权，地址为 https://www.xiaonuo.vip
 */
package vip.xiaonuo.disk.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollStreamUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.RandomUtil;
import cn.hutool.core.util.StrUtil;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qiwenshare.common.constant.FileConstant;
import com.qiwenshare.common.util.DateUtil;
import com.qiwenshare.common.util.MimeUtils;
import com.qiwenshare.ufop.exception.operation.UploadException;
import com.qiwenshare.ufop.operation.preview.Previewer;
import com.qiwenshare.ufop.operation.preview.domain.PreviewFile;
import org.apache.commons.collections4.CollectionUtils;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import vip.xiaonuo.common.enums.CommonSortOrderEnum;
import vip.xiaonuo.common.exception.CommonException;
import vip.xiaonuo.common.page.CommonPageRequest;
import vip.xiaonuo.disk.domain.PictureFile;
import vip.xiaonuo.disk.domain.ResourceUserFile;
import vip.xiaonuo.disk.domain.UserFile;
import vip.xiaonuo.disk.dto.file.PreviewDTO;
import vip.xiaonuo.disk.dto.resourceuserfile.ResourceUserFileAddParam;
import vip.xiaonuo.disk.dto.resourceuserfile.ResourceUserFileEditParam;
import vip.xiaonuo.disk.dto.resourceuserfile.ResourceUserFileIdParam;
import vip.xiaonuo.disk.dto.resourceuserfile.ResourceUserFilePageParam;
import vip.xiaonuo.disk.io.QiwenFile;
import vip.xiaonuo.disk.mapper.ResourceUserFileMapper;
import vip.xiaonuo.disk.service.ResourceUserfileService;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.UnsupportedEncodingException;
import java.util.Base64;
import java.util.List;
import java.util.UUID;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;
import java.util.stream.Collectors;

/**
 * RESOURCE_USERFILEService接口实现类
 *
 * @author honorfire
 * @date  2025/06/26 09:29
 **/
@Service
public class ResourceUserfileServiceImpl extends ServiceImpl<ResourceUserFileMapper, ResourceUserFile> implements ResourceUserfileService {

    @Resource
    private ResourceUserFileMapper resourceUserFileMapper;
    public static Executor executor = Executors.newFixedThreadPool(20);

    @Override
    public Page<ResourceUserFile> page(ResourceUserFilePageParam ResourceUserFilePageParam) {
        QueryWrapper<ResourceUserFile> queryWrapper = new QueryWrapper<>();
        if(ObjectUtil.isAllNotEmpty(ResourceUserFilePageParam.getSortField(), ResourceUserFilePageParam.getSortOrder())) {
            CommonSortOrderEnum.validate(ResourceUserFilePageParam.getSortOrder());
            queryWrapper.orderBy(true, ResourceUserFilePageParam.getSortOrder().equals(CommonSortOrderEnum.ASC.getValue()),
                    StrUtil.toUnderlineCase(ResourceUserFilePageParam.getSortField()));
        } else {
            queryWrapper.lambda().orderByAsc(ResourceUserFile::getUserFileId);
        }
        return this.page(CommonPageRequest.defaultPage(), queryWrapper);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void add(ResourceUserFileAddParam ResourceUserFileAddParam) {
        ResourceUserFile ResourceUserFile = BeanUtil.toBean(ResourceUserFileAddParam, ResourceUserFile.class);
        this.save(ResourceUserFile);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void edit(ResourceUserFileEditParam ResourceUserFileEditParam) {
        ResourceUserFile ResourceUserFile = this.queryEntity(ResourceUserFileEditParam.getUserFileId());
        BeanUtil.copyProperties(ResourceUserFileEditParam, ResourceUserFile);
        this.updateById(ResourceUserFile);
    }

    @Transactional(rollbackFor = Exception.class)
    @Override
    public void delete(List<ResourceUserFileIdParam> ResourceUserFileIdParamList) {
        // 执行删除
        this.removeByIds(CollStreamUtil.toList(ResourceUserFileIdParamList, ResourceUserFileIdParam::getUserFileId));
    }

    @Override
    public ResourceUserFile detail(ResourceUserFileIdParam ResourceUserFileIdParam) {
        return this.queryEntity(ResourceUserFileIdParam.getUserFileId());
    }

    @Override
    public ResourceUserFile queryEntity(String id) {
        ResourceUserFile ResourceUserFile = resourceUserFileMapper.selectById(id);
        if(ObjectUtil.isEmpty(ResourceUserFile)) {
            throw new CommonException("RESOURCE_USERFILE不存在，id值为：{}", id);
        }
        return ResourceUserFile;
    }

    @Override
    public List<ResourceUserFile> selectUserFileByLikeRightFilePath(String filePath, String userId) {
        return resourceUserFileMapper.selectUserFileByLikeRightFilePath(filePath, userId);
    }

    @Override
    public void deleteResourceUserFile(String userFileId, String sessionUserId) {
        ResourceUserFile resourceUserFile = resourceUserFileMapper.selectById(userFileId);
        String uuid = UUID.randomUUID().toString();
        if (resourceUserFile.getIsDir() == 1) {
            LambdaUpdateWrapper<ResourceUserFile> resourceUserFileLambdaUpdateWrapper = new LambdaUpdateWrapper<ResourceUserFile>();
            resourceUserFileLambdaUpdateWrapper.set(ResourceUserFile::getDeleteFlag, RandomUtil.randomInt(FileConstant.deleteFileRandomSize))
                    .set(ResourceUserFile::getDeleteBatchNum, uuid)
                    .set(ResourceUserFile::getDeleteTime, DateUtil.getCurrentTime())
                    .eq(ResourceUserFile::getUserFileId, userFileId);
            resourceUserFileMapper.update(null, resourceUserFileLambdaUpdateWrapper);

            String filePath = new QiwenFile(resourceUserFile.getFilePath(), resourceUserFile.getFileName(), true).getPath();
            updateFileDeleteStateByFilePath(filePath, uuid, sessionUserId);

        } else {
            LambdaUpdateWrapper<ResourceUserFile> resourceUserFileLambdaUpdateWrapper = new LambdaUpdateWrapper<>();
            resourceUserFileLambdaUpdateWrapper.set(ResourceUserFile::getDeleteFlag, RandomUtil.randomInt(1, FileConstant.deleteFileRandomSize))
                    .set(ResourceUserFile::getDeleteTime, DateUtil.getCurrentTime())
                    .set(ResourceUserFile::getDeleteBatchNum, uuid)
                    .eq(ResourceUserFile::getUserFileId, userFileId);
            resourceUserFileMapper.update(null, resourceUserFileLambdaUpdateWrapper);
        }

    }

    private void updateFileDeleteStateByFilePath(String filePath, String deleteBatchNum, String userId) {
        executor.execute(() -> {
            List<ResourceUserFile> fileList = resourceUserFileMapper.selectUserFileByLikeRightFilePath(filePath, userId);
            List<String> userFileIds = fileList.stream().map(ResourceUserFile::getUserFileId).collect(Collectors.toList());

            //标记删除标志
            if (CollectionUtils.isNotEmpty(userFileIds)) {
                LambdaUpdateWrapper<ResourceUserFile> resourceUserFileLambdaUpdateWrapper1 = new LambdaUpdateWrapper<>();
                resourceUserFileLambdaUpdateWrapper1.set(ResourceUserFile::getDeleteFlag, RandomUtil.randomInt(FileConstant.deleteFileRandomSize))
                        .set(ResourceUserFile::getDeleteTime, DateUtil.getCurrentTime())
                        .set(ResourceUserFile::getDeleteBatchNum, deleteBatchNum)
                        .in(ResourceUserFile::getUserFileId, userFileIds)
                        .eq(ResourceUserFile::getDeleteFlag, "NOT_DELETE");
                resourceUserFileMapper.update(null, resourceUserFileLambdaUpdateWrapper1);
            }
        });
    }


}
